/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*        *
*    Rutoken    PKCS#11   C++:      *
*  -   ;                                        *
*  -     ;                            *
*  -       ;                  *
*  -       .                   *
************************************************************************/
    
    
#include "Common.h"


/************************************************************************
*   ""                           *
************************************************************************/
DWORD g_dwCurTab = 0;

/************************************************************************
*                           *
************************************************************************/
void GenerateRandomData( IN  DWORD   dwDataSize,
                         OUT PBYTE&  pbtData )
                        
{
    static bool bSrandInited = false;
    if(!bSrandInited)
    {
        srand((unsigned)time(NULL));
        bSrandInited = true;
    }    
    pbtData = new BYTE[dwDataSize];    
    ::ZeroMemory(pbtData,
                 (dwDataSize*sizeof(BYTE)));
    for(DWORD i = 0;
        i < dwDataSize;
        i++)
    {
        pbtData[i] = (BYTE)rand();
    }
}

/************************************************************************
*                                               *
************************************************************************/
void PrintBuffer( IN PBYTE pbtData,
                  IN DWORD dwDataSize )
{
    PBYTE  pbtTempBuffer  = pbtData;
    DWORD  dwBytesInRow   = 16;
    LPTSTR lpszTempString = new TCHAR[dwBytesInRow * 3 + 2];
    for(DWORD i = 0;
        i < dwDataSize;
        i += dwBytesInRow)
    {
        ::ZeroMemory(lpszTempString,
                     ((dwBytesInRow * 3 + 2) * sizeof(TCHAR)));        
        DWORD j = 0;
        for(j = 0;
            j < (DWORD)min( dwBytesInRow, dwDataSize - i );
            j++)
        {
            _stprintf_s((lpszTempString + j * 3),
                        4,
                        TEXT("%02X "),
                        pbtData[i + j]);
        }
        _stprintf_s((lpszTempString + j * 3),
                     2,
                     TEXT("\n"));

        PrintTextWithTab(lpszTempString);
    }
    delete[] lpszTempString;
}

/************************************************************************
*        ANSI              *
************************************************************************/
void PrintBufferAsCharString( IN LPTSTR lpszText,
                              IN PBYTE  pbtData,
                              IN DWORD  dwDataSize )
{
    CHAR lpszCharTemp[TEMP_BUFFER_SIZE];
    ::ZeroMemory(lpszCharTemp,
                 (TEMP_BUFFER_SIZE * sizeof(CHAR)));
    if(lpszText)
        PrintTextWithTab(lpszText);    
    ::CopyMemory(lpszCharTemp,
                 pbtData,
                 dwDataSize);
    printf(lpszCharTemp);
    PrintString(TEXT("\n"));
}

/************************************************************************
*       BYTE,    *
************************************************************************/
void PrintDotSeparatedByteValue( IN LPTSTR lpszText,
                                 IN BYTE   btValue1,
                                 IN BYTE   btValue2 )
{
    TCHAR lpszTemp[TEMP_BUFFER_SIZE];
    ::ZeroMemory(lpszTemp,
                 (TEMP_BUFFER_SIZE * sizeof(TCHAR)));
    _stprintf_s(lpszTemp,
                TEXT("%s%d.%d\n"),
                lpszText,
                btValue1,
                btValue2);
    PrintTextWithTab(lpszTemp);
}

/************************************************************************
*      DWORD                         *
************************************************************************/
void PrintDwordWithString( IN LPTSTR lpszText,
                           IN DWORD  dwValue )
{
    TCHAR lpszTemp[TEMP_BUFFER_SIZE];
    ::ZeroMemory(lpszTemp,
                 (TEMP_BUFFER_SIZE * sizeof(TCHAR)));
    _stprintf_s(lpszTemp,
                TEXT("%s0x%08X\n"),
                lpszText,
                dwValue);
    PrintTextWithTab(lpszTemp);
}

/************************************************************************
*    DWORD                                       *
************************************************************************/
void PrintDword(IN DWORD dwValue)
{
    TCHAR lpszTemp[TEMP_BUFFER_SIZE];
    ::ZeroMemory(lpszTemp,
                 (TEMP_BUFFER_SIZE * sizeof(TCHAR)));
    _stprintf_s(lpszTemp,
                TEXT("0x%8.8X"),
                dwValue );
    PrintString(lpszTemp);
}

/************************************************************************
*                                                      *
************************************************************************/
void PrintString( IN LPTSTR lpszString )
{
    if (lpszString)
    {    
        _tprintf(lpszString);
    }
}

/************************************************************************
*        ""                 *
************************************************************************/
void PrintTextWithTab(IN LPTSTR lpszString)
{
    PrintTab();
    PrintString(lpszString);
}

/************************************************************************
*      ""                             *
************************************************************************/
void PrintTab()
{
    for (DWORD i = 0;
         i < g_dwCurTab;
         i++)
    {
        PrintString(TEXT(" "));
    }
}

/************************************************************************
*         ""  *
************************************************************************/
void IncreaseTab(IN DWORD dwIncrement)
{
    g_dwCurTab += dwIncrement;
}

/************************************************************************
*         ""  *
************************************************************************/
void DecreaseTab(IN DWORD dwDecrement)
{
    if(g_dwCurTab >= dwDecrement)
    {
        g_dwCurTab -= dwDecrement;
    }
}

/************************************************************************
*                      *
************************************************************************/
void PrintDone()
{
    PrintString(TEXT("\nTest has been completed succesfully.\n"));    
    PrintString(TEXT("\nPress Enter to exit.\n"));
    getchar();
}

/************************************************************************
*                                *
************************************************************************/
void PrintLastError(IN LPTSTR lpszErrorMessage,
                    IN DWORD  dwErrorCode)
{
    _tprintf(TEXT("Error: %s\n"), lpszErrorMessage);
    _tprintf(TEXT("Error code: 0x%x.\n"), dwErrorCode);
    PrintString(TEXT("Press Enter to exit.\n"));
    getchar();
}