/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*                     *
*      Rutoken       * 
* PKCS#11   C++:                                                 *
*  -  ;                                          * 
*  -  ;                                        *
*  -   ;                                           *
*  -  ;                                               *
*  -  ;                                               *
*  -  ,  .                          *
************************************************************************/

/************************************************************************
*   rtPKCS11.h.                                           *
*  rtPKCS11.h          *
*  PKCS#11,   :                                *
*  -    PKCS#11;                             *
*  -     PKCS#11.                  *
************************************************************************/

/************************************************************************
*   Common.h.                                             *
*  Common.h  **               *
*     /              *
*  Win32 API.                                                   *
************************************************************************/
    

#ifndef PKCS11_COMMON_H
#define PKCS11_COMMON_H

#include "rtPKCS11.h"
#include "Common.h"

    
/*   PKCS#11 */
#define PKCS11_LIBRARY_NAME                         TEXT("rtPKCS11.dll")
#define PKCS11ECP_LIBRARY_NAME                      TEXT("rtPKCS11ECP.dll")

/* DEMO    RSA */
static CK_UTF8CHAR PUBLIC_RSA_KEY_LABEL[] =         {"Sample RSA Public Key (Aktiv Co.)"};

/* DEMO    RSA */
static CK_UTF8CHAR PRIVATE_RSA_KEY_LABEL[] =        {"Sample RSA Private Key (Aktiv Co.)"};

/* DEMO ID   RSA */
static CK_BYTE RSA_KEY_PAIR_ID[] =                  {"RSA sample keypair ID (Aktiv Co.)"};

/* DEMO    #1   34.10-2001 */
static CK_UTF8CHAR PUBLIC_GOST_KEY_LABEL_1[] =      {"Sample GOST R 34.10-2001 Public Key 1 (Aktiv Co.)"};

/* DEMO    #1   34.10-2001 */
static CK_UTF8CHAR PRIVATE_GOST_KEY_LABEL_1[] =     {"Sample GOST R 34.10-2001 Private Key 1 (Aktiv Co.)"};

/* DEMO    #2   34.10-2001 */
static CK_UTF8CHAR PUBLIC_GOST_KEY_LABEL_2[] =      {"Sample GOST R 34.10-2001 Public Key 2 (Aktiv Co.)"};

/* DEMO    #2   34.10-2001 */
static CK_UTF8CHAR PRIVATE_GOST_KEY_LABEL_2[] =     {"Sample GOST R 34.10-2001 Private Key 2 (Aktiv Co.)"};

/* DEMO ID   #1   34.10-2001 */
static CK_BYTE GOST_KEY_PAIR_ID_1[] =               {"GOST R 34.10-2001 sample keypair 1 ID (Aktiv Co.)"};

/* DEMO ID   # 2   34.10-2001 */
static CK_BYTE GOST_KEY_PAIR_ID_2[] =               {"GOST R 34.10-2001 sample keypair 2 ID (Aktiv Co.)"};

/* DEMO PIN-  Rutoken */
static CK_UTF8CHAR USER_PIN[] =                     {'1', '2', '3', '4', '5', '6', '7', '8'};

/*  DEMO PIN-  Rutoken */
static CK_UTF8CHAR NEW_USER_PIN[] =                 {'5', '5', '5', '5', '5', '5', '5', '5'};

/*  DEMO PIN-  Rutoken */
static CK_UTF8CHAR WRONG_USER_PIN[] =               {'0', '0', '0', '0', '0', '0', '0', '0'};

/* DEMO PIN-   Rutoken */
static CK_UTF8CHAR SO_PIN[] =                       {'8', '7', '6', '5', '4', '3', '2', '1'};

/* DEMO  Rutoken ("") */
static CK_CHAR TOKEN_LONG_LABEL[]    =              {"!!!Sample Rutoken Long-long-long-long-long label!!!"};

/* DEMO  Rutoken ("") */
static CK_CHAR TOKEN_STD_LABEL[]    =               {"!!!Sample Rutoken label!!!"};

/*     28147-89   */
#define GOST_28147_KEY_SIZE                         0x20

/*  , a     */
typedef struct  
{
    CK_ATTRIBUTE_PTR    m_aTemplates;
    CK_ULONG            m_ulCount;
}TEMPLATE_INFO, *PTEMPLATE_INFO;



/************************************************************************
*                    *
*  PKCS#11:                                                  *
*  -  ;                                              *
*  -  ;                                       *
*  -      PKCS#11;                      *
*  -   ;                                            *
*  -      ;                           *
*  -    ;                               *
*  -                      *
*         .             *
************************************************************************/
bool Init( IN  LPTSTR                 lpszPKCS11_Library_Name,  //   ,     PKCS#11
           IN  CK_FLAGS               ckFlags,                  //    
           IN  CK_USER_TYPE           userType,                 //  ,    , CKU_USER  CKU_SO
           IN  const CK_UTF8CHAR_PTR  strPIN,                   //   ,  PIN-
           IN  CK_ULONG               nPIN_Length,              //  ,  PIN-,    
           OUT HMODULE&               hModule,                  //    PKCS#11
           OUT CK_SLOT_ID&            slotID,                   //  ,       
           OUT CK_SESSION_HANDLE&     hSession,                 //       
           OUT CK_FUNCTION_LIST_PTR&  pFunction_List,           //     PKCS#11,    CK_FUNCTION_LIST
           OUT bool&                  bIs_Rutoken_ECP,          //  .  true -   Rutoken ECP,  false -   Rutoken\Rutoken S  
           OUT CK_RV&                 ckResult                  //  .     ,   PKCS#11
          );

/************************************************************************
*                *
*  PKCS#11:                                                  *
*  -   ;                                            *
*  -    ;                                       *
*  -  ;                                     *
*  -    .                                    *
************************************************************************/
bool Free( IN  HMODULE&               hModule,        //    PKCS#11
           IN  CK_SLOT_ID             slotID,         //  ,       
           IN  CK_SESSION_HANDLE&     hSession,       //   
           IN  CK_FUNCTION_LIST_PTR&  pFunction_List, //     PKCS#11,    CK_FUNCTION_LIST
           OUT CK_RV&                 ckResult        //  .     ,   PKCS#11
          );

/************************************************************************
*   ,                      *
************************************************************************/
bool GetTokenClass( IN  HMODULE&    hModule,       //    PKCS#11     
                    IN  CK_SLOT_ID  ulSlotID,      //     
                    OUT bool&       bIsRutokenECP, //  .  true -   Rutoken ECP,  false -   Rutoken\Rutoken S
                    OUT CK_RV&      ckResult       //  .     ,   PKCS#11
                   );

/************************************************************************
*    CKA_VALUE                 *
************************************************************************/
bool GetObjectValue( IN  CK_SESSION_HANDLE     hSession,       //   
                     IN  CK_FUNCTION_LIST_PTR  pFunctionList,  //     PKCS#11,    CK_FUNCTION_LIST
                     IN  CK_OBJECT_HANDLE      hObject,        //  
                     OUT CK_BYTE_PTR&          pbtValue,       //   ,       CKA_VALUE 
                     OUT CK_ULONG&             ulValueSize,    //       CKA_VALUE  
                     OUT CK_RV&                ckResult        //  .     ,   PKCS#11
                    );

/************************************************************************
*    CKA_VALUE                            *
************************************************************************/
void SetValueToObjectTemplate( IN CK_ATTRIBUTE_PTR pTemplate,   //   ,      CKA_VALUE
                               IN CK_ULONG         ulCount,     //    
                               IN CK_BYTE_PTR      pbtValue,    //   ,     CKA_VALUE
                               IN CK_ULONG         ulValueSize  //      
                              );

/************************************************************************
*          *
************************************************************************/
bool FindObjects( IN  CK_SESSION_HANDLE      hSesion,        //   
                  IN  CK_FUNCTION_LIST_PTR   pFunctionList,  //     PKCS#11,    CK_FUNCTION_LIST    
                  IN  CK_ATTRIBUTE_PTR       pTemplates,     //   ,      
                  IN  CK_ULONG               ulCount,        //     
                  IN  CK_OBJECT_HANDLE_PTR&  phObject,       //     ,   
                  OUT CK_ULONG&              ulObjectCount,  //    
                  OUT CK_RV&                 ckResult        //  .     ,   PKCS#11
                 );

/**********************************************************************
*                                      *
**********************************************************************/
bool HashData( IN  CK_SESSION_HANDLE     hSession,          //      
               IN  CK_FUNCTION_LIST_PTR  pFunctionList,     //     PKCS#11,    CK_FUNCTION_LIST 
               IN  CK_MECHANISM_PTR      pHashMechanism,    //     
               IN  CK_BYTE_PTR           pbtDataToHash,     //       
               IN  CK_ULONG              ulDataToHashSize,  //        
               OUT CK_BYTE_PTR&          pbtHash,           //   ,      
               OUT CK_ULONG&             ulHashSize,        //  ,      ,  
               OUT CK_RV&                ckResult           //  .     ,   PKCS#11
              );

/**********************************************************************
*                                 *
**********************************************************************/
bool SignData( IN  CK_SESSION_HANDLE    hSession,                     //      
               IN  CK_FUNCTION_LIST_PTR pFunctionList,                //     PKCS#11,    CK_FUNCTION_LIST   
               IN  CK_ATTRIBUTE_PTR     pSignerKeyFindTemplate,       //       
               IN  CK_ULONG             ulSignerKeyFindTemplateSize,  //        
               IN  CK_MECHANISM_PTR     pHashMechanism,               //     
               IN  CK_MECHANISM_PTR     pSignatureMechanism,          //     
               IN  CK_BYTE_PTR          pbtDataToSign,                //       
               IN  CK_ULONG             ulDataToSignSize,             //        
               OUT CK_BYTE_PTR&         pbtSignature,                 //   ,     
               OUT CK_ULONG&            ulSignatureSize,              //  ,     ,  
               OUT CK_RV&               ckResult                      //  .     ,   PKCS#11
              );

/**********************************************************************
*                                    *
**********************************************************************/
bool VerifySignature( IN  CK_SESSION_HANDLE    hSession,                      //      
                      IN  CK_FUNCTION_LIST_PTR pFunctionList,                 //     PKCS#11,    CK_FUNCTION_LIST
                      IN  CK_ATTRIBUTE_PTR     pVerifierKeyFindTemplate,      //       
                      IN  CK_ULONG             ulVerifierKeyFindTemplateSize, //        
                      IN  CK_MECHANISM_PTR     pHashMechanism,                //     
                      IN  CK_MECHANISM_PTR     pSignatureMechanism,           //     
                      IN  CK_BYTE_PTR          pbtDataToSign,                 //      
                      IN  CK_ULONG             ulDataToSignSize,              //       
                      IN  CK_BYTE_PTR          pbtSignature,                  //   ,  
                      IN  CK_ULONG             ulSignatureSize,               //  ,  ,  
                      OUT CK_RV&               ckResult                       //  .     ,   PKCS#11
                     );

#endif //PKCS11_COMMON_H