/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*        Rutoken:    *
*  -    Rutoken    ;        *
*  -     Rutoken (Login);         *
*  -      34.10-2001;                          *
*  -      Rutoken (Logout)       *
*      Rutoken.                                              *
*-----------------------------------------------------------------------*
*                        *
*   PKCS#11.                                                *
*              *
*    PKCS#11.                                         *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/*     */
CK_OBJECT_CLASS ocPubKey         = CKO_PUBLIC_KEY;
CK_OBJECT_CLASS ocPrivKey        = CKO_PRIVATE_KEY;
CK_BBOOL        ckbTrue_         = CK_TRUE;
CK_BBOOL        ckbFalse_        = CK_FALSE;
CK_KEY_TYPE     ktGOST34_10_2001 = CKK_GOSTR3410;    

/************************************************************************
*        34.10-2001                 * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST34_10_2001ExchPublicKeyTmpl_1[] = 
{
    { CKA_CLASS,    &ocPubKey,                            sizeof(ocPubKey)},
    { CKA_LABEL,    (CK_VOID_PTR)PUBLIC_GOST_KEY_LABEL_1, (CK_ULONG)sizeof(PUBLIC_GOST_KEY_LABEL_1)-1},
    { CKA_ID,       (CK_VOID_PTR)GOST_KEY_PAIR_ID_1,      (CK_ULONG)sizeof(GOST_KEY_PAIR_ID_1)-1},
    { CKA_KEY_TYPE, &ktGOST34_10_2001,                    sizeof(ktGOST34_10_2001)},    
    { CKA_ENCRYPT,  &ckbTrue_,                            sizeof(ckbTrue_)},
    { CKA_TOKEN,    &ckbTrue_,                            sizeof(ckbTrue_)},
    { CKA_PRIVATE,  &ckbFalse_,                           sizeof(ckbFalse_)},    
    { CKA_DERIVE,   &ckbTrue_,                            sizeof(ckbTrue_)}
};

/************************************************************************
*        34.10-2001                 * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST34_10_2001ExchPrivateKeyTmpl_1[] = 
{
    { CKA_CLASS,    &ocPrivKey,                            sizeof(ocPrivKey)},
    { CKA_LABEL,    (CK_VOID_PTR)PRIVATE_GOST_KEY_LABEL_1, (CK_ULONG)sizeof(PRIVATE_GOST_KEY_LABEL_1)-1},
    { CKA_ID,       (CK_VOID_PTR)GOST_KEY_PAIR_ID_1,       (CK_ULONG)sizeof(GOST_KEY_PAIR_ID_1)-1},
    { CKA_KEY_TYPE, &ktGOST34_10_2001,                     sizeof(ktGOST34_10_2001)},    
    { CKA_DECRYPT,  &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_TOKEN,    &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_PRIVATE,  &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_DERIVE,   &ckbTrue_,                             sizeof(ckbTrue_)}    
};

/************************************************************************
*        34.10-2001                 * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST34_10_2001ExchPublicKeyTmpl_2[] = 
{
    { CKA_CLASS,    &ocPubKey,                            sizeof(ocPubKey)},
    { CKA_LABEL,    (CK_VOID_PTR)PUBLIC_GOST_KEY_LABEL_2, (CK_ULONG)sizeof(PUBLIC_GOST_KEY_LABEL_2)-1},
    { CKA_ID,       (CK_VOID_PTR)GOST_KEY_PAIR_ID_2,      (CK_ULONG)sizeof(GOST_KEY_PAIR_ID_2)-1},
    { CKA_KEY_TYPE, &ktGOST34_10_2001,                    sizeof(ktGOST34_10_2001)},    
    { CKA_ENCRYPT,  &ckbTrue_,                            sizeof(ckbTrue_)},
    { CKA_TOKEN,    &ckbTrue_,                            sizeof(ckbTrue_)},
    { CKA_PRIVATE,  &ckbFalse_,                           sizeof(ckbFalse_)},    
    { CKA_DERIVE,   &ckbTrue_,                            sizeof(ckbTrue_)}
};

/************************************************************************
*        34.10-2001                 * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST34_10_2001ExchPrivateKeyTmpl_2[] = 
{
    { CKA_CLASS,    &ocPrivKey,                            sizeof(ocPrivKey)},
    { CKA_LABEL,    (CK_VOID_PTR)PRIVATE_GOST_KEY_LABEL_2, (CK_ULONG)sizeof(PRIVATE_GOST_KEY_LABEL_2)-1},
    { CKA_ID,       (CK_VOID_PTR)GOST_KEY_PAIR_ID_2,       (CK_ULONG)sizeof(GOST_KEY_PAIR_ID_2)-1},
    { CKA_KEY_TYPE, &ktGOST34_10_2001,                     sizeof(ktGOST34_10_2001)},    
    { CKA_DECRYPT,  &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_TOKEN,    &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_PRIVATE,  &ckbTrue_,                             sizeof(ckbTrue_)},
    { CKA_DERIVE,   &ckbTrue_,                             sizeof(ckbTrue_)}
};

/*        34.10-2001 */
CK_MECHANISM ckmGOST34_10_2001KeyGenMech = { CKM_GOSTR3410_KEY_PAIR_GEN, NULL_PTR, 0  };


/************************************************************************
* main()                                                                *
************************************************************************/
int main(int argc, char* argv[])
{
    HMODULE               hModulePKCS11                   = NULL_PTR; //    PKCS#11
    CK_SLOT_ID            slotID                          = 0;        //  ,       
    CK_SESSION_HANDLE     hSession = NULL_PTR;                        //   
    CK_FUNCTION_LIST_PTR  pFunctionList                   = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST

    CK_OBJECT_HANDLE      hGOST34_10_2001ExchPublicKey_1  = NULL_PTR; //      34.10-2001 (      )
    CK_OBJECT_HANDLE      hGOST34_10_2001ExchPrivateKey_1 = NULL_PTR; //      34.10-2001 (      )
    CK_OBJECT_HANDLE      hGOST34_10_2001ExchPublicKey_2  = NULL_PTR; //      34.10-2001 (      )
    CK_OBJECT_HANDLE      hGOST34_10_2001ExchPrivateKey_2 = NULL_PTR; //      34.10-2001 (      )

    bool                  bResult                         = false;    //       .                   
    CK_RV                 ckResult                        = CKR_OK;   //      .                    

    bool                  bIsRutokenECP                   = false;    //       .                     

    while(true)
    {
        /**********************************************************************
        *  1:        PKCS#11.  *
        **********************************************************************/
        bResult = Init( PKCS11ECP_LIBRARY_NAME,
                        CKF_SERIAL_SESSION | CKF_RW_SESSION,
                        CKU_USER,
                        (const CK_UTF8CHAR_PTR)USER_PIN,
                        (CK_ULONG)sizeof(USER_PIN),
                        hModulePKCS11,
                        slotID,
                        hSession,
                        pFunctionList,
                        bIsRutokenECP,
                        ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  2:  .                                             *
        **********************************************************************/
        if(bIsRutokenECP)
        {
            /**********************************************************************
            *       34.10-2001                *
            **********************************************************************/
            PrintTextWithTab(TEXT("Generating GOST R 34.10-2001 exchange key pair 1...\n"));
            PrintTextWithTab(TEXT("C_GenerateKeyPair:...\n"));
            ckResult = pFunctionList->C_GenerateKeyPair(    hSession,
                                                            &ckmGOST34_10_2001KeyGenMech,
                                                            attrGOST34_10_2001ExchPublicKeyTmpl_1,
                                                            arraysize(attrGOST34_10_2001ExchPublicKeyTmpl_1),
                                                            attrGOST34_10_2001ExchPrivateKeyTmpl_1,
                                                            arraysize(attrGOST34_10_2001ExchPrivateKeyTmpl_1),
                                                            &hGOST34_10_2001ExchPublicKey_1,
                                                            &hGOST34_10_2001ExchPrivateKey_1 );
            bResult = (ckResult == CKR_OK);
            if(!bResult)
            {
                PrintTextWithTab(TEXT(" -> Failed\n"));
                break;
            }
            PrintTextWithTab(TEXT(" -> OK\n"));

            /**********************************************************************
            *       34.10-2001                *
            **********************************************************************/
            PrintTextWithTab(TEXT("Generating GOST R 34.10-2001 exchange key pair 2...\n"));
            PrintTextWithTab(TEXT("C_GenerateKeyPair:...\n"));
            ckResult = pFunctionList->C_GenerateKeyPair(    hSession,
                                                            &ckmGOST34_10_2001KeyGenMech,
                                                            attrGOST34_10_2001ExchPublicKeyTmpl_2,
                                                            arraysize(attrGOST34_10_2001ExchPublicKeyTmpl_2),
                                                            attrGOST34_10_2001ExchPrivateKeyTmpl_2,
                                                            arraysize(attrGOST34_10_2001ExchPrivateKeyTmpl_2),
                                                            &hGOST34_10_2001ExchPublicKey_2,
                                                            &hGOST34_10_2001ExchPrivateKey_2 );
            bResult = (ckResult == CKR_OK);
            if(!bResult)
            {
                PrintTextWithTab(TEXT(" -> Failed\n"));
                break;
            }
            PrintTextWithTab(TEXT(" -> OK\n"));
        }
        break;
    }

    /**********************************************************************
    *  3:                          *  
    *          PKCS#11.                                       *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free(   hModulePKCS11,
            slotID,
            hSession,
            pFunctionList,
            ckTempResult);

    if(!bResult)
    {
        PrintLastError( TEXT("Some error occurred."),
                        ckResult);
    }    
    else
    {
        PrintDone();
    }
    return bResult;
}

