/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*     PKCS#11:                      *
*  -    Rutoken    ;        *
*  -     Rutoken (Login);         *
*  -   DEMO-,    ;           *
*  -      Rutoken (Logout)       *
*      Rutoken.                                              *
*-----------------------------------------------------------------------*
*                     *
*   PKCS#11.                                                *
*     PKCS#11,    Rutoken  *
*  (.  ..\Create)    .   *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/************************************************************************
*      RSA                                   * 
* (     )                              *
************************************************************************/
CK_ATTRIBUTE attrRSAExchKeyPairTmpl[] = 
{
    {CKA_ID, (CK_VOID_PTR)RSA_KEY_PAIR_ID, (CK_ULONG)(sizeof(RSA_KEY_PAIR_ID)-1)}
};


/************************************************************************
* main()                                                                *
************************************************************************/
int main(int argc, char* argv[])
{    
    HMODULE               hModulePKCS11 = NULL_PTR; //    PKCS#11
    CK_SLOT_ID            slotID        = 0;        //  ,       
    CK_SESSION_HANDLE     hSession      = NULL_PTR; //   
    CK_FUNCTION_LIST_PTR  pFunctionList = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST

    CK_OBJECT_HANDLE_PTR  aHandles      = NULL_PTR; //     ,   
    CK_ULONG              ulCount       = 0;        //     

    bool                  bResult       = false;    //       
    CK_RV                 ckResult      = CKR_OK;   //      

    bool                  bIsRutokenECP = false;    //       

    while(true)
    {
        /**********************************************************************
        *  1:        PKCS#11.  *
        **********************************************************************/
        bResult = Init( PKCS11_LIBRARY_NAME,
                        CKF_SERIAL_SESSION | CKF_RW_SESSION,
                        CKU_USER,
                        (const CK_UTF8CHAR_PTR)USER_PIN,
                        (CK_ULONG)sizeof(USER_PIN),
                        hModulePKCS11,
                        slotID,
                        hSession,
                        pFunctionList,
                        bIsRutokenECP,
                        ckResult);
        if(!bResult)
        {
            break;
        }

        /************************************************************************
        *  2:    ,      *
        *        .                                                        *
        ************************************************************************/        
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                attrRSAExchKeyPairTmpl,
                                arraysize(attrRSAExchKeyPairTmpl),
                                aHandles,
                                ulCount,
                                ckResult);
        if(!bResult)
        {
            break;
        }

        for(DWORD i = 0;
            i < ulCount;
            i++ )
        {
            /************************************************************************
            *  3:     (   ). *
            ************************************************************************/
            PrintTextWithTab(TEXT("C_DestroyObject...\n"));
            ckResult = pFunctionList->C_DestroyObject( hSession,
                                                       aHandles[i]);
            bResult = (ckResult == CKR_OK);
            if(!bResult)
            {
                PrintTextWithTab(TEXT(" -> Failed\n"));
                break;
            }
            PrintTextWithTab(TEXT(" -> OK\n"));
        }
        if(!bResult)
        {
            break;
        }
        break;
    }
    if(aHandles)
    {
        delete[] aHandles;
        aHandles = NULL_PTR;
    }

    /**********************************************************************
    *  4:                          *
    *          PKCS#11.                                       *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free(   hModulePKCS11,
            slotID,
            hSession,
            pFunctionList,
            ckTempResult);

    if(!bResult)
    {
        PrintLastError( TEXT("Some error occurred."),
                        ckResult);
    }
    else
    {
        PrintDone();
    }
    return bResult;
}