/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*     PKCS#11:                      *
*  -    Rutoken    ;        *
*  -     Rutoken (Login);         *
*  -   DEMO-,    ;           *
*  -      Rutoken (Logout)       *
*      Rutoken.                                              *
*-----------------------------------------------------------------------*
*                     *
*   PKCS#11.                                                *
*     PKCS#11,    Rutoken  *
*  (.  ..\Create)    .   *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/************************************************************************
*        34.10-2001                     * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_1[] = 
{
    { CKA_ID, (CK_VOID_PTR)GOST_KEY_PAIR_ID_1, (CK_ULONG)(sizeof(GOST_KEY_PAIR_ID_1) - 1) }
};

/************************************************************************
*        34.10-2001                     * 
* (      )                       *
************************************************************************/
CK_ATTRIBUTE attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_2[] = 
{
    { CKA_ID, (CK_VOID_PTR)GOST_KEY_PAIR_ID_2, (CK_ULONG)(sizeof(GOST_KEY_PAIR_ID_2) - 1) }
};

/*        */
TEMPLATE_INFO aTemplates_To_Delete[] = 
{
    {attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_1, arraysize(attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_1)},
    {attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_2, arraysize(attrGOST_34_10_2001_Exch_Key_Pair_Tmpl_2)}
};

/************************************************************************
* main()                                                                *
************************************************************************/
int main(int argc, char* argv[])
{    
    HMODULE               hModulePKCS11 = NULL_PTR; //    PKCS#11
    CK_SLOT_ID            slotID        = 0;        //  ,       
    CK_SESSION_HANDLE     hSession      = NULL_PTR; //   
    CK_FUNCTION_LIST_PTR  pFunctionList = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST

    CK_OBJECT_HANDLE_PTR  aHandles      = NULL_PTR; //     ,   
    CK_ULONG              ulCount       = 0;        //     
    
    bool                  bResult       = false;    //       
    CK_RV                 ckResult      = CKR_OK;   //      

    bool                  bIsRutokenECP = false;    //       

    while(true)
    {
        /**********************************************************************
        *  1:        PKCS#11.  *
        **********************************************************************/
        bResult = Init( PKCS11ECP_LIBRARY_NAME,
                        CKF_SERIAL_SESSION | CKF_RW_SESSION,
                        CKU_USER,
                        (const CK_UTF8CHAR_PTR)USER_PIN,
                        (CK_ULONG)sizeof(USER_PIN),
                        hModulePKCS11,
                        slotID,
                        hSession,
                        pFunctionList,
                        bIsRutokenECP,
                        ckResult);
        if(!bResult)
        {
            break;
        }

        /************************************************************************
        *  2:     ,   . *
        ************************************************************************/        
        PrintTextWithTab(TEXT("Searching and deleting objects...\n"));
        IncreaseTab(3);
        for(DWORD i = 0;
             i < (DWORD)arraysize(aTemplates_To_Delete);
             i++)
        {
            /************************************************************************
            *  2.1:    ,    *
            *           (   ).                          *
            ************************************************************************/        
            bResult = FindObjects(  hSession,
                                    pFunctionList,
                                    aTemplates_To_Delete[i].m_aTemplates,
                                    aTemplates_To_Delete[i].m_ulCount,
                                    aHandles,
                                    ulCount,
                                    ckResult );
            if(!bResult)
            {
                break;
            }

            for(DWORD j = 0;
                j < (DWORD)ulCount;
                j++)
            {
                /************************************************************************
                *  2.2:                                    *
                *          (   ).                             *
                ************************************************************************/
                PrintTextWithTab(TEXT("C_DestroyObject...\n"));
                ckResult = pFunctionList->C_DestroyObject(  hSession,
                                                            aHandles[j]);
                bResult = (ckResult == CKR_OK);
                if(!bResult)
                {
                    PrintTextWithTab(TEXT(" -> Failed\n"));
                    break;
                }
                PrintTextWithTab(TEXT(" -> OK\n"));
            }

            if(!bResult)
            {
                break;
            }

            delete[] aHandles;
            aHandles = NULL_PTR;
            ulCount = 0;
        }

        DecreaseTab(3);
        if(!bResult)
        {
            break;
        }
        break;
    }

    if(aHandles)
    {
        delete[] aHandles;
        aHandles = NULL_PTR;
    }

    /**********************************************************************
    *  3:                          *
    *          PKCS#11.                                        *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free(   hModulePKCS11,
            slotID,
            hSession,
            pFunctionList,
            ckTempResult);

    if(!bResult)
    {
        PrintLastError( TEXT("Some error occurred."),
                        ckResult);
    }
    else
    {
        PrintDone();
    }
    return bResult;
}