/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*     ,     *
*  :                                                            *
*  -    Rutoken    ;        *
*  -      ;                          *
*  -      ;                    *
*  -      ;                          *
*  -      .                  *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/*     */
CK_BBOOL        ckbTrue_          = CK_TRUE;
CK_BBOOL        ckbFalse_         = CK_FALSE;
CK_OBJECT_CLASS ocPubKey          = CKO_PUBLIC_KEY;
CK_OBJECT_CLASS ocPrivKey         = CKO_PRIVATE_KEY;
CK_OBJECT_CLASS ocSecKey          = CKO_SECRET_KEY;
CK_KEY_TYPE     ktGOST28147_89Key = CKK_GOST28147;

/*      */
CK_GOSTR3410_DERIVE_PARAMS ckDeriveParams = {CKD_CPDIVERSIFY_KDF, NULL_PTR, 0, NULL_PTR, 0};

/*   /  */
CK_MECHANISM ckmWrapMech = { CKM_GOST28147_KEY_WRAP, NULL_PTR, 0 };

/*       */
CK_ATTRIBUTE attrSenderPrivateKey[] = 
{
    { CKA_ID,    (CK_VOID_PTR)GOST_KEY_PAIR_ID_1, sizeof(GOST_KEY_PAIR_ID_1)-1},
    { CKA_CLASS, &ocPrivKey,                      sizeof(ocPrivKey) }
};

/*       */
CK_ATTRIBUTE attrRecipientPrivateKey[] = 
{
    { CKA_ID,    (CK_VOID_PTR)GOST_KEY_PAIR_ID_2, sizeof(GOST_KEY_PAIR_ID_2)-1},
    { CKA_CLASS, &ocPrivKey,                      sizeof(ocPrivKey) }
};

/*       */
CK_ATTRIBUTE attrSenderPublicKey[] = 
{
    { CKA_ID,    (CK_VOID_PTR)GOST_KEY_PAIR_ID_1, sizeof(GOST_KEY_PAIR_ID_1)-1},
    { CKA_CLASS, &ocPubKey,                       sizeof(ocPubKey) }
};

/*       */
CK_ATTRIBUTE attrRecipientPublicKey[] = 
{
    { CKA_ID,    (CK_VOID_PTR)GOST_KEY_PAIR_ID_2, sizeof(GOST_KEY_PAIR_ID_2)-1},
    { CKA_CLASS, &ocPubKey,                       sizeof(ocPubKey) }
};
 
/*      */
static const CK_UTF8CHAR DERIVED_GOST_28147_89_LABEL[] =    {"Derived GOST 28147-89 key"};

/*       */
CK_ATTRIBUTE attrGOST28147_89DerivedKey[] = 
{
    { CKA_CLASS,       &ocSecKey,                                sizeof(ocSecKey)},
    { CKA_LABEL,       (CK_VOID_PTR)DERIVED_GOST_28147_89_LABEL, (CK_ULONG)(sizeof(DERIVED_GOST_28147_89_LABEL) - 1)},
    { CKA_KEY_TYPE,    &ktGOST28147_89Key,                       sizeof(ktGOST28147_89Key)},
    { CKA_TOKEN,       &ckbFalse_,                               sizeof(ckbFalse_)},
    { CKA_MODIFIABLE,  &ckbTrue_,                                sizeof(ckbTrue_)},
    { CKA_PRIVATE,     &ckbFalse_,                               sizeof(ckbFalse_)},
    { CKA_EXTRACTABLE, &ckbTrue_,                                sizeof(ckbTrue_)}     
 };

/*     */
static const CK_UTF8CHAR GOST_28147_89_KEY_TO_WRAP_LABEL[] =    {"GOST 28147-89 key to wrap"};

/*    */
CK_ATTRIBUTE attrGOST28147_89KeyToWrap[] = 
{
    { CKA_CLASS,       &ocSecKey,                                    sizeof(ocSecKey)},
    { CKA_LABEL,       (CK_VOID_PTR)GOST_28147_89_KEY_TO_WRAP_LABEL, (CK_ULONG)(sizeof(GOST_28147_89_KEY_TO_WRAP_LABEL) - 1) },
    { CKA_KEY_TYPE,    &ktGOST28147_89Key,                           sizeof(ktGOST28147_89Key)},
    { CKA_TOKEN,       &ckbFalse_,                                   sizeof(ckbFalse_)},
    { CKA_MODIFIABLE,  &ckbTrue_,                                    sizeof(ckbTrue_)},
    { CKA_PRIVATE,     &ckbFalse_,                                   sizeof(ckbFalse_)},
    { CKA_VALUE,       NULL_PTR,                                     0},
    { CKA_EXTRACTABLE, &ckbTrue_,                                    sizeof(ckbTrue_)}    
};

/*     */
static const CK_UTF8CHAR UNWRAPPED_GOST_28147_89_KEY_LABEL[] = {"Unwrapped GOST 28147-89 key"};

/*    */
CK_ATTRIBUTE attrGOST28147_89UnwrappedKey[] = 
{
    { CKA_CLASS,       &ocSecKey,                                      sizeof(ocSecKey)},
    { CKA_LABEL,       (CK_VOID_PTR)UNWRAPPED_GOST_28147_89_KEY_LABEL, (CK_ULONG)(sizeof(UNWRAPPED_GOST_28147_89_KEY_LABEL) - 1)},
    { CKA_KEY_TYPE,    &ktGOST28147_89Key,                             sizeof(ktGOST28147_89Key)},
    { CKA_TOKEN,       &ckbFalse_,                                     sizeof(ckbFalse_)},
    { CKA_MODIFIABLE,  &ckbTrue_,                                      sizeof(ckbTrue_)},
    { CKA_PRIVATE,     &ckbFalse_,                                     sizeof(ckbFalse_)},
    { CKA_EXTRACTABLE, &ckbTrue_,                                      sizeof(ckbTrue_)}    
};

/**********************************************************************
*     28147-89        *
**********************************************************************/
bool DeriveKey( IN  CK_SESSION_HANDLE     hSession,                      //  
                IN  CK_FUNCTION_LIST_PTR  pFunctionList,                 //     PKCS#11,    CK_FUNCTION_LIST
                IN  CK_ATTRIBUTE_PTR      pPrivateKeyFindTemplate,       //        
                IN  CK_ULONG              ulPrivateKeyFindTemplateSize,  //         
                IN  CK_ATTRIBUTE_PTR      pPublicKeyFindTemplate,        //        
                IN  CK_ULONG              ulPublicKeyFindTemplateSize,   //         
                OUT CK_OBJECT_HANDLE&     hDerivedKey,                   //    
                OUT CK_RV&                ckResult                       //  .     ,   PKCS#11
              )
{

    bool                 bResult                = false;    //       

    CK_OBJECT_HANDLE_PTR ahPrivateKeys          = NULL_PTR; //       ,   
    CK_ULONG             ulPrivateKeysNumber    = 0;        //        

    CK_OBJECT_HANDLE_PTR ahPublicKeys           = NULL_PTR; //       ,   
    CK_ULONG             ulPublicKeysNumber     = 0;        //        
    
    CK_MECHANISM         ckmDerivationMechanism = {CKM_GOSTR3410_DERIVE, NULL_PTR, 0}; //    
    
    CK_BYTE_PTR          pbtDerivedKey          = NULL_PTR; //   ,    
    CK_ULONG             ulDerivedKeySize       = 0;        //  ,    ,  
 
    PrintTextWithTab(TEXT("Deriving key...\n"));
    IncreaseTab(3);
    while(true)
    {
        /************************************************************************
        *                         *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting sender key...\n"));        
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                pPrivateKeyFindTemplate,
                                ulPrivateKeyFindTemplateSize,
                                ahPrivateKeys,
                                ulPrivateKeysNumber,
                                ckResult );
        if(!bResult)
        {
            break;
        }
        if(ulPrivateKeysNumber == 0)
        {
            PrintTextWithTab(TEXT("No private key found!!!\n"));
            bResult = false;
            break;
        }

        /************************************************************************
        *                          *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting public key...\n"));
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                pPublicKeyFindTemplate,
                                ulPublicKeyFindTemplateSize,
                                ahPublicKeys,
                                ulPublicKeysNumber,
                                ckResult );
        if(!bResult)
        {
            break;
        }
        if(ulPublicKeysNumber == 0)
        {
            PrintTextWithTab(TEXT("No public key found!!!\n"));
            bResult = false;
            break;
        }
 
        /************************************************************************
        *     CK_GOSTR3410_DERIVE_PARAMS                 * 
        *                                                 * 
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting public key value...\n"));
        bResult = GetObjectValue(   hSession,
                                    pFunctionList,
                                    ahPublicKeys[0],
                                    ckDeriveParams.pPublicData,
                                    ckDeriveParams.ulPublicDataLen,
                                    ckResult);
        if(!bResult)
        {
            break;
        }

 
        /************************************************************************
        *     CK_MECHANISM ,         *
        *                                                *
        ************************************************************************/
        ckmDerivationMechanism.pParameter     = &ckDeriveParams;
        ckmDerivationMechanism.ulParameterLen = sizeof(ckDeriveParams);


        /************************************************************************
        *     28147-89               *
        *                              *
        ************************************************************************/
        PrintTextWithTab(TEXT("C_DeriveKey...\n"));
        ckResult = pFunctionList->C_DeriveKey(  hSession,
                                                &ckmDerivationMechanism,
                                                ahPrivateKeys[0],
                                                attrGOST28147_89DerivedKey,
                                                arraysize(attrGOST28147_89DerivedKey),
                                                &hDerivedKey);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *        28147-89                *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting derived key value...\n"));
        bResult = GetObjectValue(   hSession,
                                    pFunctionList,
                                    hDerivedKey,
                                    pbtDerivedKey,
                                    ulDerivedKeySize,
                                    ckResult );
        if(!bResult)
        {
            break;
        }

        /************************************************************************
        *        28147-89             *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Derived key data is:\n"));
        PrintBuffer( pbtDerivedKey,
                     ulDerivedKeySize );
        break;
    }

    if(ahPrivateKeys)
    {
        delete[] ahPrivateKeys;
        ahPrivateKeys = NULL_PTR;
    }

    if(ahPublicKeys)
    {
        delete[] ahPublicKeys;
        ahPublicKeys = NULL_PTR;
    }

    if(ckDeriveParams.pPublicData)
    {
        delete[] ckDeriveParams.pPublicData;
        ckDeriveParams.pPublicData     = NULL_PTR;
        ckDeriveParams.ulPublicDataLen = 0;
    }

    if(pbtDerivedKey)
    {
        delete[] pbtDerivedKey;
        pbtDerivedKey = NULL_PTR;
    }

    if(!bResult)
    {
        pFunctionList->C_DestroyObject( hSession,
                                        hDerivedKey );
        hDerivedKey = NULL_PTR;
    }

    DecreaseTab(3);
    
    if(bResult)
    {
        PrintTextWithTab(TEXT("Deriving has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("Deriving failed!\n\n"));
    }
    return bResult;
}

/**********************************************************************
*                                                      *
**********************************************************************/
bool WrapKey(IN  CK_SESSION_HANDLE    hSession,                 //  
             IN  CK_FUNCTION_LIST_PTR pFunctionList,            //     PKCS#11,    CK_FUNCTION_LIST
             IN  CK_OBJECT_HANDLE     hWrappingKey,             //  ,     
             IN  CK_ATTRIBUTE_PTR     pKeyToWrapTemplate,       //       
             IN  CK_ULONG             ulKeyToWrapTemplateSize,  //        
             OUT CK_BYTE_PTR&         pbtWrappedKey,            //   ,        
             OUT CK_ULONG&            ulWrappedKeySize,         //      ,  
             OUT CK_RV&               ckResult                  //  .     ,   PKCS#11
             )
{
    bool             bResult      = false;     //       
    CK_OBJECT_HANDLE hKey_To_Wrap = NULL_PTR;  //  ,   
    
    pbtWrappedKey    = NULL_PTR;               
    ulWrappedKeySize = 0;    
    
    PrintTextWithTab(TEXT("Wrapping key...\n"));
    IncreaseTab(3);
    while(true)
    {
        /************************************************************************
        *  ,                                   *
        ************************************************************************/
        PrintTextWithTab(TEXT("Creating the GOST 28147-89 key to wrap...\n"));
        ckResult = pFunctionList->C_CreateObject(   hSession,
                                                    pKeyToWrapTemplate,
                                                    ulKeyToWrapTemplateSize,
                                                    &hKey_To_Wrap);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *   ,         *
        ************************************************************************/
        PrintTextWithTab(TEXT("Wrapping key step 1...\n"));
        ckResult = pFunctionList->C_WrapKey(    hSession,
                                                &ckmWrapMech,
                                                hWrappingKey,
                                                hKey_To_Wrap,
                                                NULL_PTR,
                                                &ulWrappedKeySize);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
                
        pbtWrappedKey = new CK_BYTE[ulWrappedKeySize];
        ::ZeroMemory(   pbtWrappedKey,
                        ulWrappedKeySize*sizeof(CK_BYTE));

        /************************************************************************
        *                                              *
        ************************************************************************/
        PrintTextWithTab(TEXT("Wrapping key step 2...\n"));
        ckResult = pFunctionList->C_WrapKey(hSession,
                                            &ckmWrapMech,
                                            hWrappingKey,
                                            hKey_To_Wrap,
                                            pbtWrappedKey,
                                            &ulWrappedKeySize);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *  ,                         *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Wrapped key data:\n"));
        PrintBuffer( pbtWrappedKey,
                     ulWrappedKeySize );
        break;

    }
    if(!bResult)
    {
        if(pbtWrappedKey)
        {
            delete[]pbtWrappedKey;
            pbtWrappedKey = NULL_PTR;
        }
    }
    if(hKey_To_Wrap)
    {
        /************************************************************************
        *  ,                                     *        
        ************************************************************************/
        pFunctionList->C_DestroyObject( hSession,
                                        hKey_To_Wrap);
        hKey_To_Wrap = NULL_PTR;
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Wrapping has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("Wrapping failed!\n\n"));
    }
    return bResult;
}

/**********************************************************************
*                                                    *
**********************************************************************/
bool UnwrapKey(IN  CK_SESSION_HANDLE    hSession,                   //  
               IN  CK_FUNCTION_LIST_PTR pFunctionList,              //     PKCS#11,    CK_FUNCTION_LIST
               IN  CK_OBJECT_HANDLE     hUnwrappingKey,             //  ,     
               IN  CK_ATTRIBUTE_PTR     pUnwrappedKeyTemplate,      //       
               IN  CK_ULONG             ulUnwrapedKeyTemplateSize,  //        
               IN  CK_BYTE_PTR          pbtWrappedKey,              //   ,                     
               IN  CK_ULONG             ulWrappedKeySize,           //      ,  
               OUT CK_BYTE_PTR&         pbtUnwrappedKey,            //   ,                      
               OUT CK_ULONG&            ulUnwrappedKeySize,         //      ,  
               OUT CK_RV&               ckResult                    //  .     ,   PKCS#11
              )
{
    bool             bResult        = false;    //       
    CK_OBJECT_HANDLE hUnwrapped_Key = NULL_PTR; //   

    PrintTextWithTab(TEXT("Unwrapping key...\n"));
    IncreaseTab(3);    
    while(true)
    {
        /************************************************************************
        *                                                      *
        ************************************************************************/
        PrintTextWithTab(TEXT("Unwrapping key...\n"));
        ckResult = pFunctionList->C_UnwrapKey(  hSession,
                                                &ckmWrapMech,
                                                hUnwrappingKey,
                                                pbtWrappedKey,
                                                ulWrappedKeySize,
                                                pUnwrappedKeyTemplate,
                                                ulUnwrapedKeyTemplateSize,
                                                &hUnwrapped_Key);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *                          *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting unwrapped key value...\n"));
        bResult = GetObjectValue(   hSession,
                                    pFunctionList,
                                    hUnwrapped_Key,
                                    pbtUnwrappedKey,
                                    ulUnwrappedKeySize,
                                    ckResult );
        if(!bResult)
        {
            break;
        }

        /************************************************************************
        *                       *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Unwrapped key data:\n"));
        PrintBuffer(pbtUnwrappedKey,
                    ulUnwrappedKeySize );
        break;
    }
    if(!bResult)
    {
        if(pbtUnwrappedKey)
        {
            delete[] pbtUnwrappedKey;
            pbtUnwrappedKey    = NULL_PTR;
            ulUnwrappedKeySize = 0;
        }
    }
    if(hUnwrapped_Key)
    {
        /************************************************************************
        *  ,                                   *        
        ************************************************************************/
        pFunctionList->C_DestroyObject( hSession,
                                        hUnwrapped_Key);
        hUnwrapped_Key = NULL_PTR;
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Unwrapping has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("Unwrapping failed!\n\n"));
    }
    return bResult;
}
 
/************************************************************************
* main()                                                                *
************************************************************************/
 int main(void)
 {
    HMODULE               hModulePKCS11      = NULL_PTR; //    PKCS#11
    CK_SLOT_ID            slotID             = 0;        //  ,       
    CK_SESSION_HANDLE     hSession           = NULL_PTR; //        
    CK_FUNCTION_LIST_PTR  pFunctionList      = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST
     
    CK_OBJECT_HANDLE      hDerivedKey_1      = NULL_PTR; //        
    CK_OBJECT_HANDLE      hDerivedKey_2      = NULL_PTR; //        
     
    bool                  bResult            = false;    //       
    CK_RV                 ckResult           = CKR_OK;   //      

    bool                  bIsRutokenECP      = false;    //       

    CK_BYTE_PTR           pbtSessionKey      = NULL_PTR; //   ,     

    CK_BYTE_PTR           pbtWrappedKey      = NULL_PTR; //   ,         
    CK_ULONG              ulWrappedKeySize   = 0;        //          ,  

    CK_BYTE_PTR           pbtUnwrappedKey    = NULL_PTR; //   ,         
    CK_ULONG              ulUnwrappedKeySize = 0;        //          ,  
        
    while(true)
    {
        /**********************************************************************
        *      CK_GOSTR3410_DERIVE_PARAMS    *
        *                                              *
        **********************************************************************/
        ckDeriveParams.ulUKMLen = 8;
        GenerateRandomData( ckDeriveParams.ulUKMLen,
                            ckDeriveParams.pUKM );        

        /**********************************************************************
        *      CK_MECHANISM                  *
        *                                                 *
        **********************************************************************/
        ckmWrapMech.ulParameterLen = 8;
        GenerateRandomData( ckmWrapMech.ulParameterLen,
                            (CK_BYTE_PTR&)ckmWrapMech.pParameter );

        /**********************************************************************
        *                                        *
        **********************************************************************/
        GenerateRandomData( GOST_28147_KEY_SIZE,
                            pbtSessionKey);

        SetValueToObjectTemplate(   attrGOST28147_89KeyToWrap,
                                    arraysize(attrGOST28147_89KeyToWrap),
                                    pbtSessionKey,
                                    GOST_28147_KEY_SIZE);

        PrintTextWithTab(TEXT("Session key data is: \n"));
        PrintBuffer(    pbtSessionKey,
                        GOST_28147_KEY_SIZE );         

        /**********************************************************************
        *  1:        PKCS#11.  *
        **********************************************************************/
        bResult = Init( PKCS11ECP_LIBRARY_NAME,
                        CKF_SERIAL_SESSION | CKF_RW_SESSION,
                        CKU_USER,
                        (const CK_UTF8CHAR_PTR)USER_PIN,
                        (CK_ULONG)sizeof(USER_PIN),
                        hModulePKCS11,
                        slotID,
                        hSession,
                        pFunctionList,
                        bIsRutokenECP,
                        ckResult);
        if(!bResult)
        {
            break;
        }
        if(!bIsRutokenECP)
        {
            PrintTextWithTab(TEXT("This test is not applicable with current card type!\n"));
            break;
        }

        /**********************************************************************
        *  2:      .                *
        **********************************************************************/
        bResult = DeriveKey(    hSession,
                                pFunctionList,
                                attrSenderPrivateKey,
                                arraysize(attrSenderPrivateKey),
                                attrRecipientPublicKey,
                                arraysize(attrRecipientPublicKey),
                                hDerivedKey_1,
                                ckResult );
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  3:          *
        *           .                                *
        **********************************************************************/
        bResult = WrapKey(  hSession,
                            pFunctionList,
                            hDerivedKey_1,
                            attrGOST28147_89KeyToWrap,
                            arraysize(attrGOST28147_89KeyToWrap),
                            pbtWrappedKey,
                            ulWrappedKeySize,
                            ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  4:      .                 *
        **********************************************************************/
        bResult = DeriveKey(    hSession,
                                pFunctionList,
                                attrRecipientPrivateKey,
                                arraysize(attrRecipientPrivateKey),
                                attrSenderPublicKey,
                                arraysize(attrSenderPublicKey),
                                hDerivedKey_2,
                                ckResult );
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  5:        *
        *           .                                 *
        **********************************************************************/
        bResult = UnwrapKey(    hSession,
                                pFunctionList,
                                hDerivedKey_2,
                                attrGOST28147_89UnwrappedKey,
                                arraysize(attrGOST28147_89UnwrappedKey),
                                pbtWrappedKey,
                                ulWrappedKeySize,
                                pbtUnwrappedKey,
                                ulUnwrappedKeySize,
                                ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  6:                *
        *           .                         *
        **********************************************************************/
        if(   (ulUnwrappedKeySize != GOST_28147_KEY_SIZE)
            || (::memcmp(pbtSessionKey,
                         pbtUnwrappedKey,
                         GOST_28147_KEY_SIZE) != 0))
        {
            PrintTextWithTab(TEXT("\n\nThe unwrapped key is not equal to the session key!\n"));
            bResult = false;
            break;
        }
        else
        {
            PrintTextWithTab(TEXT("Congratulations!!! The unwrapped key is equal to the session key!\n"));
        }
        break;
    }

    if(hDerivedKey_1)
    {
        pFunctionList->C_DestroyObject( hSession,
                                        hDerivedKey_1);
        hDerivedKey_1 = NULL_PTR;
    }

    if(hDerivedKey_2)
    {
        pFunctionList->C_DestroyObject( hSession,
                                        hDerivedKey_2);
        hDerivedKey_2 = NULL_PTR;
    }

    /**********************************************************************
    *  7:                          *
    *          PKCS#11.                                       *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free(   hModulePKCS11,
            slotID,
            hSession,
            pFunctionList,
            ckTempResult);
 
    if(ckDeriveParams.pUKM)
    {
        delete[] ckDeriveParams.pUKM;
        ckDeriveParams.pUKM = NULL_PTR;
    }

    if(ckmWrapMech.pParameter)
    {
        delete[] ckmWrapMech.pParameter;
        ckmWrapMech.pParameter = NULL_PTR;
    }

    if(pbtSessionKey)
    {
        delete[] pbtSessionKey;
        pbtSessionKey = NULL_PTR;
    }

    if(pbtUnwrappedKey)
    {
        delete[] pbtUnwrappedKey;
        pbtUnwrappedKey = NULL_PTR;
    }

    if(pbtWrappedKey)
    {
        delete[] pbtWrappedKey;
        pbtWrappedKey = NULL_PTR;
    }
 
    if(!bResult)
    {
        PrintLastError( TEXT("Some error occurred."),
                        ckResult);
    }
    else
    {
        PrintDone();
    }
    return bResult;
 }

