/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*    Rutoken:                           *
*  -    Rutoken    ;        *
*  -  ;                                              *
*  -     SO ();           *
*  -  PIN- ;                               *
*  -    SO  Rutoken (Logout)       *
*     Rutoken.                                                         *
*-----------------------------------------------------------------------*
*                        *
*   PKCS#11                                                 *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/*   */
static CK_CHAR abtToken_Label[] = {    'M', 'y', ' ', 'R', 'u', 't', 'o', 'k',
                                       'e', 'n', ' ', ' ', ' ', ' ', ' ', ' ',
                                       ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
                                       ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' };

/************************************************************************
* main()                                                                *
************************************************************************/
int main(int argc, char* argv[])
{
    HMODULE               hModulePKCS11        = NULL_PTR; //    PKCS#11
    CK_SESSION_HANDLE     hSession             = NULL_PTR; //        

    CK_FUNCTION_LIST_PTR  pFunctionList        = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST
    CK_C_GetFunctionList  pfnGetFunctionList   = NULL_PTR; //    C_GetFunctionList

    bool                  bResult              = false;    //       
    CK_RV                 ckResult             = CKR_OK;   //          

    CK_SLOT_ID_PTR        aSlots               = NULL_PTR; //       
    CK_ULONG              ulSlotCount          = 0;        //       
        
    PrintTextWithTab(TEXT("Initializing module...\n"));
    IncreaseTab(3);
    while(true)
    {
        /**********************************************************************
        *  1:  .                                        *      
        **********************************************************************/
        PrintTextWithTab(TEXT("Loading library "));
        PrintString(PKCS11_LIBRARY_NAME);
        PrintString(TEXT("...\n"));
        hModulePKCS11 = LoadLibrary(PKCS11_LIBRARY_NAME);
        bResult = (hModulePKCS11 != NULL_PTR);
        if (!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  2:              * 
        *         .                                                  *      
        **********************************************************************/    
        PrintTextWithTab(TEXT("Getting GetFunctionListFunction...\n"));
        pfnGetFunctionList = (CK_C_GetFunctionList)GetProcAddress(hModulePKCS11,
                                                                  "C_GetFunctionList");
        bResult = (pfnGetFunctionList != NULL_PTR);
        if (!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  3:      .                 *      
        **********************************************************************/    
        PrintTextWithTab(TEXT("Getting function list...\n"));
        ckResult = pfnGetFunctionList(&pFunctionList);
        bResult = (ckResult == CKR_OK);
        if (!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  4:  .                                 *      
        **********************************************************************/
        PrintTextWithTab(TEXT("C_Initialize:...\n"));
        ckResult = pFunctionList->C_Initialize(NULL_PTR);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  5:     .                       *      
        **********************************************************************/        
        PrintTextWithTab(TEXT("Getting slot list. Step 1...\n"));
        ckResult = pFunctionList->C_GetSlotList(CK_TRUE,
                                                NULL_PTR,
                                                &ulSlotCount); 
        bResult = (ckResult == CKR_OK);
        if( !bResult )
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        if (ulSlotCount == 0)
        {
            PrintTextWithTab(TEXT("Error: no Rutoken available!\n"));
            bResult = false;
            break;
        }

        aSlots = new CK_SLOT_ID[ulSlotCount];
        ::ZeroMemory(aSlots,
                     (ulSlotCount * sizeof(CK_SLOT_ID)));

        PrintTextWithTab(TEXT("Getting slot list. Step 2...\n"));
        ckResult = pFunctionList->C_GetSlotList(    CK_TRUE,
                                                    aSlots,
                                                    &ulSlotCount); 
        bResult = (ckResult == CKR_OK);
        if( !bResult )
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));        

        DecreaseTab(3);

        /**********************************************************************
        *  6:  .                                      *      
        **********************************************************************/
        PrintTextWithTab(TEXT("C_InitToken:...\n"));        
        ckResult = pFunctionList->C_InitToken(  aSlots[0],
                                                (CK_UTF8CHAR_PTR)SO_PIN,
                                                (CK_ULONG)sizeof(SO_PIN),
                                                abtToken_Label );
        bResult = (ckResult == CKR_OK);
        if( !bResult )
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  7:      .                     *      
        **********************************************************************/        
        PrintTextWithTab(TEXT("C_OpenSession:...\n"));
        ckResult = pFunctionList->C_OpenSession(    aSlots[0],
                                                    (CKF_SERIAL_SESSION | CKF_RW_SESSION), 
                                                    0,
                                                    0,
                                                    &hSession);
        bResult = (ckResult == CKR_OK);
        if( !bResult )
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *  8:     .           *      
        **********************************************************************/
        PrintTextWithTab(TEXT("Login Admin\n"));
        PrintTextWithTab(TEXT("C_Login:...\n"));                
        ckResult = pFunctionList->C_Login(  hSession,
                                            CKU_SO,
                                            (CK_UTF8CHAR_PTR)SO_PIN,
                                            (CK_ULONG)sizeof(SO_PIN)    );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
        
        /**********************************************************************
        *  9:  PIN- .                       *
        **********************************************************************/
        PrintTextWithTab(TEXT("C_InitPin:...\n"));
        PrintTextWithTab(TEXT("Initializing User PIN...\n"));
        ckResult = pFunctionList->C_InitPIN( hSession,
                                             (CK_UTF8CHAR_PTR)USER_PIN,
                                             (CK_ULONG)sizeof(USER_PIN) );
        bResult = (ckResult == CKR_OK);
        if( !bResult )
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
        break;
    }
        
    /**********************************************************************
    *  10:                         *
    *           PKCS#11.                                      *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free( hModulePKCS11,
          aSlots[0],
          hSession,
          pFunctionList,
          ckTempResult);

    if(aSlots)
    {
        delete[] aSlots;
        aSlots = NULL_PTR;
    }

    if(!bResult)
    {
        PrintLastError( TEXT("Some error occurred."),
                        ckResult);
    }
    else
    {
        PrintDone();
    }
    return bResult;
}
