/************************************************************************
* Rutoken                                                               *
* Copyright (C) Aktiv Co. 2003 - 2011                                   *
*  :  http://www.rutoken.ru                          *
*  :    http://www.rutoken.ru/hotline/download/drivers/*
*  : http://www.rutoken.ru/hotline/                 *
*-----------------------------------------------------------------------*
*    Rutoken    PKCS#11   C++    *
*-----------------------------------------------------------------------*
*   /   RSA:         *
*  -    Rutoken    ;        *
*  -     Rutoken (Login);         *
*  -      RSA;              *
*  -                             *
       RSA;                                        *
*  -      Rutoken (Logout)                *
*        Rutoken.                                   *
*-----------------------------------------------------------------------*
*   ,    Rutoken   *
* (.  ..\Create)                                                 *
************************************************************************/

/************************************************************************
*   PKCS11_Common.h.                                      *
*  PKCS11_Common.h  **     :  *
*  -   :                                     *
      - PKCS#11;                                                        *
	  -  /;                                      *  
*     -  Win32 API;                                              * 
*  -  DEMO-;                                             *  
*  -  DEMO PIN- ;                                *
*  -  ,    .      *
************************************************************************/
    

#include "PKCS11_Common.h"


/*     */
CK_OBJECT_CLASS ocPubKey  = CKO_PUBLIC_KEY;
CK_OBJECT_CLASS ocPrivKey = CKO_PRIVATE_KEY;

/*      */
CK_ATTRIBUTE attrPubKeyFindTempl[] = 
{
    { CKA_ID,    (CK_VOID_PTR)RSA_KEY_PAIR_ID, (CK_ULONG)sizeof(RSA_KEY_PAIR_ID)-1},
    { CKA_CLASS, &ocPubKey,                    sizeof(ocPubKey)}
};

/*      */
CK_ATTRIBUTE attrPrivKeyFindTempl[] = 
{
    { CKA_ID,    (CK_VOID_PTR)RSA_KEY_PAIR_ID, (CK_ULONG)sizeof(RSA_KEY_PAIR_ID)-1},
    { CKA_CLASS, &ocPrivKey,                   sizeof(ocPrivKey)}
};

/*    */
CK_BYTE pbtData[] = { 0x00, 0x01, 0x02,0x03, 0x04, 0x05, 0x06, 0x07,
                      0x00, 0x01, 0x02,0x03, 0x04, 0x05, 0x06, 0x07,
                      0x00, 0x01, 0x02,0x03, 0x04, 0x05, 0x06, 0x07,
                      0x00, 0x01, 0x02,0x03, 0x04, 0x05, 0x06, 0x07 };

/*       RSA */
CK_MECHANISM ckmEncDecMech = {CKM_RSA_PKCS, NULL_PTR , 0};

/*   RSA */
#define RSAENH_MAGIC_RSA1        0x31415352

/**********************************************************************
*      MS CryptoAPI                   *
*                                          *
**********************************************************************/
bool MakeCAPIPublicKey( IN  CK_BYTE_PTR pbtModulus,        //   ,    CKA_MODULUS
                        IN  CK_ULONG    ulModulusSize,     //   ,   CKA_MODULUS,  
                        IN  CK_ULONG    ulPublicExponent,  //   CKA_PUBLIC_EXPONENT
                        IN  ALG_ID      algID,             //   
                        OUT PBYTE&      pbtPublicKey,      //   ,         MS CryptoAPI
                        OUT DWORD&      dwPublicKeySize    //   ,     MS CryptoAPI,  
                     )
{    
    DWORD      dwKeyDataSize = ulModulusSize;  //      
    
    BLOBHEADER blobHeader;                     //    BLOBHEADER,       MS CryptoAPI 
    RSAPUBKEY  pubKey;                         //    RSAPUBKEY,       MS CryptoAPI 

    if(dwKeyDataSize % 64 != 0)
    {
        return false;
    }
    
    ::ZeroMemory( &blobHeader,
                  sizeof(BLOBHEADER));    
    ::ZeroMemory( &pubKey,
                  sizeof(pubKey));

    /************************************************************************
    *     BLOBHEADER                            *
    ************************************************************************/
    blobHeader.bType    = PUBLICKEYBLOB;
    blobHeader.bVersion = CUR_BLOB_VERSION;
    blobHeader.aiKeyAlg = algID;
    blobHeader.reserved = 0;

    /************************************************************************
    *     RSAPUBKEY                            *
    ************************************************************************/
    pubKey.bitlen = dwKeyDataSize*8;
    pubKey.magic  = RSAENH_MAGIC_RSA1;
    pubKey.pubexp = ulPublicExponent;
    
    /************************************************************************
    *      MS CryptoAPI                     * 
    ************************************************************************/
    dwPublicKeySize = sizeof(BLOBHEADER) + sizeof(RSAPUBKEY) + dwKeyDataSize;
    pbtPublicKey = new BYTE [dwPublicKeySize];

    ::ZeroMemory(pbtPublicKey,
                 dwPublicKeySize );

    ::CopyMemory(pbtPublicKey,
                 &blobHeader,
                 sizeof(BLOBHEADER));

    ::CopyMemory(pbtPublicKey + sizeof(BLOBHEADER),
                 &pubKey,
                 sizeof(RSAPUBKEY));

    ::CopyMemory(pbtPublicKey + sizeof(BLOBHEADER) + sizeof(RSAPUBKEY),
                 pbtModulus,
                 dwKeyDataSize );
    return true;
}

/**********************************************************************
*      MS CryptoAPI                       *
**********************************************************************/
bool GetCAPIPublicKeyFromPKCS11( IN  CK_SESSION_HANDLE    hSession,                     //   
                                 IN  CK_FUNCTION_LIST_PTR pFunctionList,                //     PKCS#11,    CK_FUNCTION_LIST
                                 IN  CK_ATTRIBUTE_PTR     pPublicKeyFindTemplate,       //       
                                 IN  CK_ULONG             ulPublicKeyFindTemplateSize,  //        
                                 OUT PBYTE&               pbtCAPIPublicKey,             //   ,         MS CryptoAPI 
                                 OUT DWORD&               dwCAPIPublicKeySize,          //   ,     MS CryptoAPI,   
                                 OUT CK_RV&               ckResult                      //  .     ,   PKCS#11
                               )

{
    bool                 bResult            = false;                              //       
    
    CK_OBJECT_HANDLE_PTR ahPublicKeys       = NULL_PTR;                           //      ,   
    CK_ULONG             ulPublicKeysNumber = 0;                                  //       

    CK_ATTRIBUTE         attrModulus        = {CKA_MODULUS, NULL_PTR, 0};         //    CK_ATTRIBUTE     CKA_MODULUS
    CK_ATTRIBUTE         attrPublicExponent = {CKA_PUBLIC_EXPONENT, NULL_PTR, 0}; //    CK_ATTRIBUTE     CKA_PUBLIC_EXPONENT 
    
    PrintTextWithTab(TEXT("Retrieving public key in MS CryptoAPI format...\n"));
    IncreaseTab(3);
    while(true)
    {
        /************************************************************************
        *                                    *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting public key...\n"));
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                pPublicKeyFindTemplate,
                                ulPublicKeyFindTemplateSize,
                                ahPublicKeys,
                                ulPublicKeysNumber,
                                ckResult );
        if(!bResult)
        {
            break;
        }
        if(ulPublicKeysNumber == 0)
        {
            PrintTextWithTab(TEXT("No public key found!!!\n"));
            bResult = false;
            break;
        }

        /************************************************************************
        *    CKA_MODULUS                                *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting modulus. Step 1...\n"));
        ckResult = pFunctionList->C_GetAttributeValue(  hSession,
                                                        ahPublicKeys[0],
                                                        &attrModulus,
                                                        1);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
        
        attrModulus.pValue = new CK_BYTE[attrModulus.ulValueLen];
        ::ZeroMemory( attrModulus.pValue,
                      (attrModulus.ulValueLen * sizeof(CK_BYTE)));

        PrintTextWithTab(TEXT("Getting modulus. Step 2...\n"));
        ckResult = pFunctionList->C_GetAttributeValue(  hSession,
                                                        ahPublicKeys[0],
                                                        &attrModulus,
                                                        1);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));


        /************************************************************************
        *    CKA_PUBLIC_EXPONENT                        *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting exponent. Step 1...\n"));
        ckResult = pFunctionList->C_GetAttributeValue(  hSession,
                                                        ahPublicKeys[0],
                                                        &attrPublicExponent,
                                                        1);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        attrPublicExponent.pValue = new CK_BYTE[attrPublicExponent.ulValueLen];
        ::ZeroMemory( attrPublicExponent.pValue,
                      (attrPublicExponent.ulValueLen * sizeof(CK_BYTE)));

        PrintTextWithTab(TEXT("Getting exponent. Step 2...\n"));
        ckResult = pFunctionList->C_GetAttributeValue(  hSession,
                                                        ahPublicKeys[0],
                                                        &attrPublicExponent,
                                                        1 );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));


        /************************************************************************
        *     ,              *
        *  CKA_MODULUS                                                  *
        ************************************************************************/
        for(DWORD i = 0;
            i < (DWORD)(attrModulus.ulValueLen / 2);
            i++ )
        {
            CK_BYTE bTemp = ((CK_BYTE_PTR)attrModulus.pValue)[i];
            ((CK_BYTE_PTR)attrModulus.pValue)[i] = ((CK_BYTE_PTR)attrModulus.pValue)[attrModulus.ulValueLen - i - 1];
            ((CK_BYTE_PTR)attrModulus.pValue)[attrModulus.ulValueLen - i - 1] = bTemp;
        }

        DWORD dwExponent = 0;
        ::CopyMemory(   &dwExponent,
                        attrPublicExponent.pValue,
                        attrPublicExponent.ulValueLen);

        /************************************************************************
        *      MS CryptoAPI                     *
        ************************************************************************/
        PrintTextWithTab(TEXT("Converting to MS CryptoAPI format...\n"));
        bResult = MakeCAPIPublicKey(    (PBYTE)attrModulus.pValue,
                                        attrModulus.ulValueLen ,
                                        dwExponent,
                                        CALG_RSA_KEYX,
                                        pbtCAPIPublicKey,
                                        dwCAPIPublicKeySize );
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
        break;
    }
    if(ahPublicKeys)
    {
        delete[] ahPublicKeys;
        ahPublicKeys = NULL_PTR;
    }
    if(attrModulus.pValue)
    {
        delete[] attrModulus.pValue;
        attrModulus.pValue = NULL_PTR;
    }
    if(attrPublicExponent.pValue)
    {
        delete[] attrPublicExponent.pValue;
        attrPublicExponent.pValue = NULL_PTR;
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Public key in MS format has been retrieved successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("\n\nCannot retrieve public key in MS format!\n\n"));
    }
    return bResult;
};

/**********************************************************************
*  ,                                        *
* Microsoft Enhanced Cryptographic Provider v1.0                      *
**********************************************************************/
bool EncryptOnMSCAPI( IN  CK_SESSION_HANDLE    hSession,                     //      
                      IN  CK_FUNCTION_LIST_PTR pFunctionList,                //     PKCS#11,    CK_FUNCTION_LIST
                      IN  CK_ATTRIBUTE_PTR     pPublicKeyFindTemplate,       //       
                      IN  CK_ULONG             ulPublicKeyFindTemplateSize,  //        
                      IN  CK_BYTE_PTR          pbtDataToEncrypt,             //      
                      IN  CK_ULONG             ulDataToEncryptSize,          //     ,  
                      OUT CK_BYTE_PTR&         pbtEncryptedData,             //   ,     
                      OUT CK_ULONG&            ulEncryptedDataSize,          //    ,   
                      OUT CK_RV&               ckResult                      //  .     ,   PKCS#11
                     )
{
    bool        bResult                        = false;               //       
    
    HCRYPTPROV  hProv                          = NULL;                //   
    HCRYPTKEY   hKey                           = NULL;                //   

    PBYTE       pbtCAPIPublicKey    = NULL_PTR;                       //         MS CryptoAPI
    DWORD       dwCAPIPublicKeySize = 0;                              //        MS CryptoAPI,  
    
    CK_BYTE_PTR pbtTempData                    = NULL_PTR;            //    
    CK_ULONG    ulTempDataSize                 = ulDataToEncryptSize; //   ,   
    

    pbtEncryptedData    = NULL_PTR;
    ulEncryptedDataSize = 0;

    pbtTempData = new CK_BYTE[ulDataToEncryptSize];
    ::CopyMemory(   pbtTempData,
                    pbtDataToEncrypt,
                    (ulDataToEncryptSize* sizeof(CK_BYTE)));
    
    PrintTextWithTab(TEXT("Implementing asymmetric encryption by MS Enhanced Cryptographic Provider v1.0...\n"));
    IncreaseTab(3);
    while(true)
    {
        /**********************************************************************
        *      MS CryptoAPI                       *
        **********************************************************************/
        bResult = GetCAPIPublicKeyFromPKCS11(hSession,
                                             pFunctionList,
                                             pPublicKeyFindTemplate,
                                             ulPublicKeyFindTemplateSize,
                                             pbtCAPIPublicKey,
                                             dwCAPIPublicKeySize,
                                             ckResult );
        if(!bResult)
        {
            break;
        }    

        /**********************************************************************
        *                                      *
        **********************************************************************/
        PrintTextWithTab(TEXT("Opening MS Enhanced Cryptographic Provider v1.0 context...\n"));
        bResult = (::CryptAcquireContext(   &hProv,
                                            NULL,
                                            MS_ENHANCED_PROV,
                                            PROV_RSA_FULL,
                                            CRYPT_VERIFYCONTEXT ) == TRUE);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *                   *
        **********************************************************************/
        PrintTextWithTab(TEXT("Importing public key...\n"));
        bResult = (::CryptImportKey(    hProv,
                                        pbtCAPIPublicKey,
                                        dwCAPIPublicKeySize,
                                        NULL,
                                        0,
                                        &hKey ) == TRUE);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *                                             *
        **********************************************************************/
        PrintTextWithTab(TEXT("Encrypting data. Step 1...\n"));
        ulEncryptedDataSize = 0;
        bResult = (::CryptEncrypt(  hKey,
                                    NULL,
                                    TRUE,
                                    0,
                                    NULL,
                                    &ulEncryptedDataSize,
                                    0 ) == TRUE);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));
        
        pbtEncryptedData = new BYTE[ulEncryptedDataSize];
        ::ZeroMemory( pbtEncryptedData,
                      ulEncryptedDataSize );

        DWORD dwAllocated_Size = ulEncryptedDataSize;
        DWORD dwData_Size = ulTempDataSize;

        ::CopyMemory( pbtEncryptedData,
                      pbtTempData,
                      ulTempDataSize);

        PrintTextWithTab(TEXT("Encrypting data. Step 2...\n"));
        bResult = (::CryptEncrypt(  hKey,
                                    NULL,
                                    TRUE,
                                    0,
                                    pbtEncryptedData,
                                    &dwData_Size,
                                    dwAllocated_Size ) == TRUE);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *     ,            *
        ************************************************************************/
        for(DWORD i =0;
            i < (ulEncryptedDataSize / 2);
            i++)
        {
            CK_BYTE bTemp = pbtEncryptedData[i];
            pbtEncryptedData[i] = pbtEncryptedData[ulEncryptedDataSize - i - 1];
            pbtEncryptedData[ulEncryptedDataSize - i - 1] = bTemp;
        }

        /************************************************************************
        *  ,                                *
        ************************************************************************/
        PrintTextWithTab(TEXT("Encrypted buffer text:\n"));
        PrintBuffer(    pbtEncryptedData,
                        ulEncryptedDataSize );
        break;
    }
    if(hKey)
    {
        CryptDestroyKey(hKey);
        hKey = NULL;
    }
    if(hProv)
    {
        CryptReleaseContext(hProv,0);
        hProv = NULL;
    }
    if(pbtCAPIPublicKey)
    {
        delete[] pbtCAPIPublicKey;
        pbtCAPIPublicKey = NULL_PTR;
    }
    if(pbtTempData)
    {
        delete[] pbtTempData;
        pbtTempData = NULL_PTR;
    }
    if(!bResult)
    {
        if(pbtEncryptedData)
        {
            delete[] pbtEncryptedData;
            pbtEncryptedData    = NULL_PTR;
            ulEncryptedDataSize = 0;
        }
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Encryption has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("\n\nEncryption failed!\n\n"));
    }
    return bResult;
}

/**********************************************************************
*  ,   PKCS#11                    *
**********************************************************************/
bool EncryptOnPKCS11( IN  CK_SESSION_HANDLE    hSession,                    //      
                      IN  CK_FUNCTION_LIST_PTR pFunctionList,               //     PKCS#11,    CK_FUNCTION_LIST
                      IN  CK_ATTRIBUTE_PTR     pPublicKeyFindTemplate,      //       
                      IN  CK_ULONG             ulPublicKeyFindTemplateSize, //        
                      IN  CK_BYTE_PTR          pbtDataToEncrypt,            //      
                      IN  CK_ULONG             ulDataToEncryptSize,         //     ,  
                      OUT CK_BYTE_PTR&         pbtEncryptedData,            //   ,     
                      OUT CK_ULONG&            ulEncryptedDataSize,         //    ,  
                      OUT CK_RV&               ckResult                     //  .     ,   PKCS#11
                     )
{
    bool                 bResult            = false;               //           

    CK_OBJECT_HANDLE_PTR ahPublicKeys       = NULL_PTR;            //      ,   
    CK_ULONG             ulPublicKeysNumber = 0;                   //       
    
    CK_BYTE_PTR          pbtTempData        = NULL_PTR;            //    
    CK_ULONG             ulTempDataSize     = ulDataToEncryptSize; //          

    pbtEncryptedData    = NULL_PTR;
    ulEncryptedDataSize = 0;
    
    pbtTempData = new CK_BYTE[ulDataToEncryptSize];
    ::CopyMemory(   pbtTempData,
                    pbtDataToEncrypt,
                    (ulDataToEncryptSize* sizeof(CK_BYTE)));    


    PrintTextWithTab(TEXT("Implementing asymmetric encryption...\n"));
    IncreaseTab(3);
    while(true)
    {
        /************************************************************************
        *                                    *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting public key...\n")); 
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                pPublicKeyFindTemplate,
                                ulPublicKeyFindTemplateSize,
                                ahPublicKeys,
                                ulPublicKeysNumber,
                                ckResult );
        if(!bResult)
        {
            break;
        }
        if(ulPublicKeysNumber == 0)
        {
            PrintTextWithTab(TEXT("No public key found!!!\n"));
            bResult = false;
            break;
        }

        /**********************************************************************
        *                                   *
        **********************************************************************/
        PrintTextWithTab(TEXT("C_EncryptInit...\n"));
        ckResult = pFunctionList->C_EncryptInit(hSession,
                                                &ckmEncDecMech,
                                                ahPublicKeys[0]);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *                                             *
        **********************************************************************/
        PrintTextWithTab(TEXT("C_Encrypt step 1...\n"));
        ckResult = pFunctionList->C_Encrypt(hSession,
                                            pbtTempData,
                                            ulTempDataSize,
                                            NULL_PTR,
                                            &ulEncryptedDataSize );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        pbtEncryptedData = new CK_BYTE[ulEncryptedDataSize];
        ::ZeroMemory(pbtEncryptedData,
                     (ulEncryptedDataSize * sizeof(CK_BYTE)));

        PrintTextWithTab(TEXT("C_Encrypt step 2...\n"));
        ckResult = pFunctionList->C_Encrypt(hSession,
                                            pbtTempData,
                                            ulTempDataSize,
                                            pbtEncryptedData,
                                            &ulEncryptedDataSize );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /************************************************************************
        *  ,                                *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Encrypted buffer is:\n"));
        PrintBuffer( pbtEncryptedData,
                     ulEncryptedDataSize );
        break;
    }
    if(ahPublicKeys)
    {
        delete[] ahPublicKeys;
        ahPublicKeys = NULL_PTR;
    }
    if(pbtTempData)
    {
        delete[] pbtTempData;
        pbtTempData = NULL_PTR;
    }
    if(!bResult)
    {
        if(pbtEncryptedData)
        {
            delete[] pbtEncryptedData;
            pbtEncryptedData    = NULL_PTR;
            ulEncryptedDataSize = 0;
        }
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Encryption has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("\n\nEncryption failed!\n\n"));
    }
    return bResult;
}

/**********************************************************************
*  ,   PKCS#11                   *
**********************************************************************/
bool DecryptOnPKCS11( IN  CK_SESSION_HANDLE    hSession,                     //      
                      IN  CK_FUNCTION_LIST_PTR pFunctionList,                //     PKCS#11,    CK_FUNCTION_LIST
                      IN  CK_ATTRIBUTE_PTR     pSenderKeyFindTemplate,       //       
                      IN  CK_ULONG             ulSenderKeyFindTemplateSize,  //        
                      IN  CK_BYTE_PTR          pbtDataToDecrypt,             //     
                      IN  CK_ULONG             ulDataToDecryptSize,          //    ,  
                      OUT CK_BYTE_PTR&         pbtDecryptedData,             //   ,      
                      OUT CK_ULONG&            ulDecryptedDataSize,          //   ,     ,  
                      OUT CK_RV&               ckResult                      //  .     ,   PKCS#11
                    )
{
    bool                 bResult            = false;               //           

    CK_OBJECT_HANDLE_PTR ahPrivateKeys       = NULL_PTR;           //      ,   
    CK_ULONG             ulPrivateKeysNumber = 0;                  //       

    CK_BYTE_PTR          pbtTempData        = NULL_PTR;            //    
    CK_ULONG             ulTempDataSize     = ulDataToDecryptSize; //          
    
    pbtDecryptedData    = NULL_PTR;
    ulDecryptedDataSize = 0;
    

    pbtTempData = new CK_BYTE[ulDataToDecryptSize];
    ::CopyMemory(  pbtTempData,
                   pbtDataToDecrypt,
                   (ulDataToDecryptSize* sizeof(CK_BYTE)));
    
    PrintTextWithTab(TEXT("Implementing asymmetric decryption...\n"));
    IncreaseTab(3);
    while(true)
    {        
        /************************************************************************
        *                                    *
        ************************************************************************/
        PrintTextWithTab(TEXT("Getting private key...\n")); 
        bResult = FindObjects(  hSession,
                                pFunctionList,
                                pSenderKeyFindTemplate,
                                ulSenderKeyFindTemplateSize,
                                ahPrivateKeys,
                                ulPrivateKeysNumber,
                                ckResult );
        if(!bResult)
        {
            break;
        }
        if(ulPrivateKeysNumber == 0)
        {
            PrintTextWithTab(TEXT("No private key found!!!\n"));
            bResult = false;
            break;
        }

        /**********************************************************************
        *                                *
        **********************************************************************/
        PrintTextWithTab(TEXT("C_DecryptInit...\n"));
        ckResult = pFunctionList->C_DecryptInit(hSession,
                                                &ckmEncDecMech,
                                                ahPrivateKeys[0]);
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        /**********************************************************************
        *                                               *
        **********************************************************************/
        PrintTextWithTab(TEXT("C_Decrypt step 1...\n"));
        ckResult = pFunctionList->C_Decrypt(hSession,
                                            pbtTempData,
                                            ulTempDataSize,
                                            NULL_PTR,
                                            &ulDecryptedDataSize );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));

        pbtDecryptedData = new CK_BYTE[ulDecryptedDataSize];
        ::ZeroMemory( pbtDecryptedData,
                      (ulDecryptedDataSize * sizeof(CK_BYTE)));

        PrintTextWithTab(TEXT("C_Decrypt step 2...\n"));
        ckResult = pFunctionList->C_Decrypt(hSession,
                                            pbtTempData,
                                            ulTempDataSize,
                                            pbtDecryptedData,
                                            &ulDecryptedDataSize );
        bResult = (ckResult == CKR_OK);
        if(!bResult)
        {
            PrintTextWithTab(TEXT(" -> Failed\n"));
            break;
        }
        PrintTextWithTab(TEXT(" -> OK\n"));


        /************************************************************************
        *  ,                       *        
        ************************************************************************/
        PrintTextWithTab(TEXT("Decrypted buffer is:\n"));
        PrintBuffer(    pbtDecryptedData,
                        ulDecryptedDataSize );
        break;
    }
    if(ahPrivateKeys)
    {
        delete[] ahPrivateKeys;
        ahPrivateKeys = NULL_PTR;
    }
    if(pbtTempData)
    {
        delete[] pbtTempData;
        pbtTempData = NULL_PTR;
    }
    if(!bResult)
    {
        if(pbtDecryptedData)
        {
            delete[] pbtDecryptedData;
            pbtDecryptedData    = NULL_PTR;
            ulDecryptedDataSize = 0;
        }
    }
    DecreaseTab(3);
    if(bResult)
    {
        PrintTextWithTab(TEXT("Decryption has been completed successfully.\n\n"));
    }
    else
    {
        PrintTextWithTab(TEXT("Decryption failed!\n\n"));
    }
    return bResult;
}

/************************************************************************
* main()                                                                *
************************************************************************/
int main(int argc, char* argv[])
{
    HMODULE               hModulePKCS11      = NULL_PTR; //    PKCS#11
    CK_SLOT_ID            slotID             = 0;        //  ,       
    CK_SESSION_HANDLE     hSession           = NULL_PTR; //        
    CK_FUNCTION_LIST_PTR  pFunctionList      = NULL_PTR; //     PKCS#11,    CK_FUNCTION_LIST
    
    bool                  bResult            = false;    //       
    CK_RV                 ckResult           = CKR_OK;   //      .               

    bool                  bIsRutokenECP      = false;    //       .                     
    

    CK_BYTE_PTR pbtEncryptedDataOnPKCS11          = NULL_PTR; //   ,    PKCS11  
    CK_ULONG    ulEncryptedDataOnPKCS11Size       = 0;        //    ,   PKCS11,  

    CK_BYTE_PTR pbtEncryptedDataOnMSCAPI          = NULL_PTR; //   ,    CryptoAPI 
    CK_ULONG    ulEncryptedDataOnMSCAPISize       = 0;        //    ,   CryptoAPI,  

    CK_BYTE_PTR pbtDecryptedDataMSCAPIToPKCS11    = NULL_PTR; //   ,    MS CryptoAPI    PKCS11  
    CK_ULONG    ulDecryptedDataMSCAPIToPKCS11Size = 0;        //    ,   CryptoAPI    PKCS11,  

    CK_BYTE_PTR pbtDecryptedDataPKCS11ToPKCS11    = NULL_PTR; //   ,    PKCS11    PKCS11  
    CK_ULONG    ulDecryptedDataPKCS11ToPKCS11Size = 0;        //    ,   PKCS11    PKCS11,  
    

    while(true)
    {
        /**********************************************************************
        *  1:        PKCS#11.  *
        **********************************************************************/
        bResult = Init( PKCS11_LIBRARY_NAME,
                        CKF_SERIAL_SESSION | CKF_RW_SESSION,
                        CKU_USER,
                        (const CK_UTF8CHAR_PTR)USER_PIN,
                        (CK_ULONG)sizeof(USER_PIN),
                        hModulePKCS11,
                        slotID,
                        hSession,
                        pFunctionList,
                        bIsRutokenECP,
                        ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  2:     RSA           *
        *        MS CryptoAPI.                                                *
        **********************************************************************/
        PrintTextWithTab(TEXT("\n\nEncrypting by MS CryptoAPI...\n"));
        bResult = EncryptOnMSCAPI(  hSession,
                                    pFunctionList,
                                    attrPubKeyFindTempl,
                                    arraysize(attrPubKeyFindTempl),
                                    pbtData,
                                    arraysize(pbtData),
                                    pbtEncryptedDataOnMSCAPI,
                                    ulEncryptedDataOnMSCAPISize,
                                    ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  3:     RSA   PKCS11. *
        **********************************************************************/
        PrintTextWithTab(TEXT("\n\nEncrypting by PKCS11...\n"));
        bResult = EncryptOnPKCS11(  hSession,
                                    pFunctionList,
                                    attrPubKeyFindTempl,
                                    arraysize(attrPubKeyFindTempl),
                                    pbtData,
                                    arraysize(pbtData),
                                    pbtEncryptedDataOnPKCS11,
                                    ulEncryptedDataOnPKCS11Size,
                                    ckResult);
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  4:    RSA ,      *
        *         MS CryptoAPI,   PKCS#11.                   *
        **********************************************************************/
        PrintTextWithTab(TEXT("\n\nDecrypting data, encrypted previously by MS CryptoAPI, by PKCS#11...\n"));
        bResult = DecryptOnPKCS11(  hSession,
                                    pFunctionList,
                                    attrPrivKeyFindTempl,
                                    arraysize(attrPrivKeyFindTempl),
                                    pbtEncryptedDataOnMSCAPI,
                                    ulEncryptedDataOnMSCAPISize,
                                    pbtDecryptedDataMSCAPIToPKCS11,
                                    ulDecryptedDataMSCAPIToPKCS11Size,
                                    ckResult );
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  5:     .                  *        
        **********************************************************************/
        if(     (ulDecryptedDataMSCAPIToPKCS11Size != arraysize(pbtData))
            ||    ::memcmp( pbtData,
                            pbtDecryptedDataMSCAPIToPKCS11,
                            ulDecryptedDataMSCAPIToPKCS11Size) != 0)
        {
            PrintTextWithTab(TEXT("\n\nThe decrypted and the plain text are different!!!\n\n"));
            bResult = false;
            break;
        }
        else
        {
            PrintTextWithTab(TEXT("The decrypted and the plain text are equal.\n"));
        }

        /**********************************************************************
        *  6:    RSA ,      *
        *         PKCS#11,   PKCS#11.                        *
        **********************************************************************/
        PrintTextWithTab(TEXT("\n\nDecrypting data, encrypted previously by PKCS#11, byPKCS#11...\n"));
        bResult = DecryptOnPKCS11(  hSession,
                                    pFunctionList,
                                    attrPrivKeyFindTempl,
                                    arraysize(attrPrivKeyFindTempl),
                                    pbtEncryptedDataOnPKCS11,
                                    ulEncryptedDataOnPKCS11Size,
                                    pbtDecryptedDataPKCS11ToPKCS11,
                                    ulDecryptedDataPKCS11ToPKCS11Size,
                                    ckResult );
        if(!bResult)
        {
            break;
        }

        /**********************************************************************
        *  7:     .                  *        
        **********************************************************************/
        if(        (ulDecryptedDataPKCS11ToPKCS11Size != arraysize(pbtData))
            ||    ::memcmp( pbtData,
                            pbtDecryptedDataPKCS11ToPKCS11,
                            ulDecryptedDataPKCS11ToPKCS11Size) != 0)
        {
            PrintTextWithTab(TEXT("\n\nThe decrypted and the plain text are different!!!\n\n"));
            bResult = false;
            break;
        }
        else
        {
            PrintTextWithTab(TEXT("The decrypted and the plain text are equal.\n"));
        }
        break;
    }

    /**********************************************************************
    *  8:                          *
    *          PKCS#11.                                       *
    **********************************************************************/
    CK_RV ckTempResult = CKR_OK;
    Free(   hModulePKCS11,
            slotID,
            hSession,
            pFunctionList,
            ckTempResult);

    if(pbtEncryptedDataOnMSCAPI)
    {
        delete[] pbtEncryptedDataOnMSCAPI;
        pbtEncryptedDataOnMSCAPI = NULL_PTR;
    }

    if(pbtEncryptedDataOnPKCS11)
    {
        delete[] pbtEncryptedDataOnPKCS11;
        pbtEncryptedDataOnPKCS11 = NULL_PTR;
    }
    if(pbtDecryptedDataMSCAPIToPKCS11)
    {
        delete [] pbtDecryptedDataMSCAPIToPKCS11;
        pbtDecryptedDataMSCAPIToPKCS11 = NULL_PTR;
    }
    if(pbtDecryptedDataPKCS11ToPKCS11)
    {
        delete[] pbtDecryptedDataPKCS11ToPKCS11;
        pbtDecryptedDataPKCS11ToPKCS11 = NULL_PTR;
    }

    if(!bResult)
    {
        PrintLastError(TEXT("Some error occurred."),
                       ckResult);
    }
    else
    {
        PrintDone();
    }
    return bResult;
}
